<?php
/*
Plugin Name: ShowHiddenDIV
Plugin URI: http://www.christianschenk.org/projects/wordpress-showhiddendiv-plugin/
Description: Shows a hidden DIV.
Version: 1.0
Author: Christian Schenk
Author URI: http://www.christianschenk.org/
*/

#
# WordPress ShowHiddenDIV plugin
# Copyright (C) 2009 Christian Schenk
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
#


/**
 * This will add the JavaScript to the footer.
 */
function shd_add_js() {
	if (!shd_get_metadata()) return;
?>

<script type="text/javascript">
var moreinfo;
var moreinfolink;
var show = '';
var hide = '';
function showhide(show,hide) {
	var showdivid = show;
	var hidedivid = hide;
	showdiv(showdivid);
	hidediv(hidedivid);
	<?php //alert('show: ' + show + ' hide: ' + ' showdivid: ' + showdivid); ?>
}
function showdiv(showdivid) {
	document.getElementById(showdivid).style.display = 'block';
}
function hidediv(hidedivid) {
	document.getElementById(hidedivid).style.display = 'none';
}
</script>
<?php
}
if (function_exists('add_action')) add_action('wp_footer', 'shd_add_js');


/**
 * Examines the metadata for the current post or page.
 */
function shd_get_metadata() {
	global $post;
	if (!isset($post)) return false;

	$meta = get_post_meta($post->ID, 'showhiddendiv', true);
	if (strlen($meta) < 1) return false;
	return true;
}


/**
 * Outputs the div and the link.
 */
function shd_shortcode($atts, $content = NULL) {
	extract(shortcode_atts(array('text' => __('Show...', 'showhiddendiv'),
	                             'linkid' => 'moreinfolink', 'divid' => 'moreinfo'), $atts));
	# sanity checks
	if ($linkid == $divid) return '';

	$rVal = '<p><a href="javascript:showhide(\''.$divid.'\',\''.$linkid.'\');" id="'.$linkid.'">'.$text.'</a></p>'.
	        '<div id="'.$divid.'" style="display: none;">'.
	        '<p>'.$content.'</p>'.
	        '</div>';

	return $rVal;
}
if (function_exists('add_shortcode'))
	foreach (array('shd', 'showhiddendiv') as $shortcode)
		add_shortcode($shortcode, 'shd_shortcode');

?>
